<!DOCTYPE HTML>  

<html>

<head>
    <title>Project no. 17</title>
    <link rel="stylesheet" type="text/css" href="css/style.css"> 
    <link rel="icon" href="images/jquery.png">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script src="node_modules/jquery-validation/dist/jquery.validate.js"></script>    
</head>

<body>  
    <div class="wrapper">
        <header class="header">
            <img  class="header__logo-image" src="images/jquery.png" alt="Logo image" title="Logo image">
        </header>        
        <!-- End of header -->
        <div class="main">
             <form id="testform" action="#" method="post">
                <fieldset class="fieldset">
                    <legend class="legend">Basic Info</legend>
                    <label id="firstname" for="firstname">First Name <span class="required">*</span></label>
                    <input type="text" name="firstname" class="std-input" placeholder="Enter your name" maxlength="20">
                    <label id="lastname" for="lastname">Last name <span class="required">*</span></label>
                    <input type="text" name="lastname" class="std-input" placeholder="Enter your last name" maxlength="20">
                    <label id="dateofbirth" for="dateofbirth">Date of Birth <span class="required">*</span></label>
                    <input type="date" name="dateofbirth" class="std-input"> 
                    <label id="email" for="email">Email <span class="required">*</span></label>
                    <input type="email" name="email" class="std-input" placeholder="john.doe@gmail.com" maxlength="30"> 
                    <label id="gender">Gender: <span class="required">*</span></label><br>
                    <label><input class="radio" type="radio" name="gender" value="male">Male</label><br>
                    <label><input class="radio" type="radio" name="gender" value="female" >Female</label><br>
                    <label><input class="radio" type="radio" name="gender" value="other" >I'm not sure</label><br>
                </fieldset>
                <fieldset class="fieldset">
                    <legend>Practical placement</legend>
                    <label id="company" for="company">Choose company <span class="required">*</span></label><br>
                    <select class="company" name="company">
                        <option value="">none</option>
                        <option value="sp">Studio Present</option>
                        <option value="icb">ICBTech</option>
                        <option value="is">Infostud</option>
                        <option value="other">Other</option>
                    </select><br><br>
                    <label id="about">Add comment <span class="required">*</span></label><br>
                    <!-- maxlength set to 250 won't allow more typing-->
                    <textarea id="textarea" name="about" class="std-input" rows="10" cols="37" maxlength="250" placeholder="About you"></textarea>
                    <div id="charsleft"></div><br><br>
                </fieldset>
                    <input class="submit-button" type="submit" name="submit" value="SUBMIT">
            </form>
        </div>
    </div> 
    
    <script>
        /*$(document).ready(function() {
            const MAX_LENGTH = 250;
            $('#charsleft').html(MAX_LENGTH + " remaining");
            
            $('#textarea').keypress(function() {
                let textLength = $('#textarea').val().length;
                //console.log(textLength);
                let textRemaining = MAX_LENGTH - textLength;
                //console.log(textRemaining);
                $('#charsleft').html(textRemaining + " remaining");
            });
        });*/

        $(document).ready(function () {
            const MAX_LENGTH = 250;
            $('#charsleft').html('(' + MAX_LENGTH + " characters remaining)");

            $('#textarea').on("input", function() {
                let textLength = $(this).val().length;
                var charsRemaining = MAX_LENGTH - textLength;
               $('#charsleft').html('(' + charsRemaining + " characters remaining)");
            });
        });

        $("#testform").validate({
            /*errorPlacement: function(error, element) {
                if (element.attr("name") == "firstname" ) {
                    error.appendTo('#firstname');
                }
            },*/
            // completely disable highlight - don't want its classes etc.
            highlight: function(element, errorClass) {
                // return ensures that function ends
                return;
            },
            unhighlight: function(element, errorClass) {
                return;
            },
            errorPlacement: function(error, element) {
                let el = '#' + element.attr("name");
                error.appendTo(el);
            },
            errorElement: "span",
            rules: {
                firstname: {
                    required: true,
                    minlength: 2
                },
                lastname: {
                    required: true,
                    minlength: 3
                },
                dateofbirth: {
                    required: true,
                    // not necessary for date is already in proper format
                    dateISO: true
                },
                email: {
                    required: true,
                    email: true
                },
                gender: {
                    required: true
                },
                company: {
                    required: true
                },
                about: {
                    required: true,
                }
            },
            messages: {
                firstname: {
                    required: "Please enter your first name",
                    minlength: jQuery.validator.format("At least {0} characters required"),
                },
                lastname: {
                    required: "Please enter your last name",
                    minlength: jQuery.validator.format("At least {0} characters required"),
                },
                email: {
                    required: "Please enter your email address",
                    email: "Proper format: name@example.com"
                }
            }
        });
    </script>
</body>

</html>